Attribute VB_Name = "Global"
Global HexagramMatrix(7, 7, 9) As Byte
Global AlphaMatrix(7, 7, 9) As String * 1
Global tmpAlphaMatrix(7, 7, 9) As String * 1
Global tmpHexagramMatrix(7, 7, 9) As Byte

Global PatternBuffer(64, 1, 9) As Long
Global MinDisPattern(64, 9) As Long
Global MaxDisPattern(64, 9) As Long

Global PatternElementals(1, 7, 1, 9) As Long
Global MinElementals(1, 7, 9) As Long
Global MaxElementals(1, 7, 9) As Long

Global PatternNuclear(1, 7, 1, 9) As Long
Global MinNuclear(1, 7, 9) As Long
Global MaxNuclear(1, 7, 9) As Long

Global NuclearYang(1, 7, 9) As Long
Global NuclearYin(1, 7, 9) As Long
Global Nuclear(1, 7, 9) As Long

Global iChingYang(9, 64) As Long
Global iChingYin(9, 64) As Long

Global Yang(9) As Long
Global Yin(9) As Long

Global ResultYang(9) As Long
Global ResultYin(9) As Long
Global PrinceYang(9) As Long
Global PrinceYin(9) As Long
Global KarmaYang(9) As Long
Global KarmaYin(9) As Long
Global MotivationYang(9) As Long
Global MotivationYin(9) As Long
Global OfficialYang(9) As Long
Global OfficialYin(9) As Long
Global OutsideCauseYang(9) As Long
Global OutsideCauseYin(9) As Long

Global ElementalsYang(1, 7, 9) As Long
Global ElementalsYin(1, 7, 9) As Long

Global Result(9) As Long '          6 ___  ___ Spirit
Global Prince(9) As Long '          5 ___  ___ Soul
Global Karma(9) As Long '           4 ___  ___ Body
Global Motivation(9) As Long '      3 ___  ___ Feeling
Global Official(9)  As Long '       2 ___  ___ Thinking
Global OutsideCause(9)  As Long '  1 ___  ___ Sensing

Global Const NumLattices = 9

Global iCounter As Double
Global iChing(2, 2, 2, 2, 2, 2) As String * 20
Global iChingDescription(64) As String * 50

Type iMatrix_Vector
    iPosX As Byte
    iPosY As Byte
    iLattices As Byte
    icA As Byte '          6 ___  ___ Spirit
    icB As Byte '          5 ___  ___ Soul
    icC As Byte '           4 ___  ___ Body
    icD As Byte '      3 ___  ___ Feeling
    icE As Byte '       2 ___  ___ Thinking
    icF As Byte '  1 ___  ___ SensingEnd Type
End Type

Global iChingOccurence(64, 9) As Long

Global Elementals(1, 7, 9) As Long

Global SupportedCharacters(9) As Long
Global UnsupportedCharacters(9) As Long
Global WordCount As Long

Global iLattices As Integer
Global iFirstTime As Boolean

Global Const Shallow2Deep = 0
Global Const Deep2Shallow = 1
Global Const Random = 2
Global Const BestYang = 3
Global Const BestYin = 4

Global Const BestElementYin = 0
Global Const BestElementYang = 1
Type iSettings
    SpaceOnSpace As Boolean
    NewLineOnvbCR As Boolean
    SpaceUnsupported As Boolean
    PrintChar   As Boolean
    MultiplexDisplay As Boolean
    Randomix As Boolean
    RandomixState As Byte
    UserSeed As Double
    DateTimeSeed As Boolean
    ResetStats As Boolean
    BestElemental As Boolean
    ElementalYangorYin As Byte
    Mayhem As Boolean
    MayhemSeed As Double
    MayhemDateTime As Boolean
End Type

Global Setting As iSettings


Global iFontName As String
Global iFontSize As Integer
Global iFontBold As Boolean
Global MatrixDESCCaption(9) As String

Public Declare Function BitBlt Lib "gdi32" (ByVal hDestDC As Long, ByVal X As Long, ByVal Y As Long, ByVal nWidth As Long, ByVal nHeight As Long, ByVal hSrcDC As Long, ByVal xSrc As Long, ByVal ySrc As Long, ByVal dwRop As Long) As Long

Public Const SRCAND = &H8800C6  ' (DWORD) dest = source AND dest
Public Const SRCCOPY = &HCC0020 ' (DWORD) dest = source
Public Const SRCERASE = &H440328        ' (DWORD) dest = source AND (NOT dest )
Public Const SRCINVERT = &H660046       ' (DWORD) dest = source XOR dest
Public Const SRCPAINT = &HEE0086        ' (DWORD) dest = source OR dest

'-----
'-----  = heaven
'-----

'-----
'-----  = Wind
'-- --

'-----
'-- --  = Flame
'-----

'-----
'-- --  = Mountain
'-- --

'-- --
'-----  = Lake
'-----

'-- --
'-----  = Water
'-- --

'-- --
'-- --  = Thunder
'-----

'-- --
'-- --  = Earth
'-- --

Function SetiChing()

    iChing(1, 1, 1, 1, 1, 1) = "01. Ch'ien"
    iChing(2, 2, 2, 2, 2, 2) = "02. K'un"
    iChing(2, 1, 2, 2, 2, 1) = "03. Chun"
    iChing(1, 2, 2, 2, 1, 2) = "04. Mng"
    iChing(2, 1, 2, 1, 1, 1) = "05. Hs"
    iChing(1, 1, 1, 2, 1, 2) = "06. Sung"
    iChing(2, 2, 2, 2, 1, 2) = "07. Shih"
    iChing(2, 1, 2, 2, 2, 2) = "08. Pi"
    iChing(1, 1, 2, 1, 1, 1) = "09. Hsiao Ch'u"
    iChing(1, 1, 1, 2, 1, 1) = "10. L"
    iChing(2, 2, 2, 1, 1, 1) = "11. T'ai"
    iChing(1, 1, 1, 2, 2, 2) = "12. P'i"
    iChing(1, 1, 1, 1, 2, 1) = "13. T'ung Jn"
    iChing(1, 2, 1, 1, 1, 1) = "14. Ta Yu"
    iChing(2, 2, 2, 1, 2, 2) = "15. Ch'ien"
    iChing(2, 2, 1, 2, 2, 2) = "16. Y"
    iChing(2, 1, 1, 2, 2, 1) = "17. Sui"
    iChing(1, 2, 2, 1, 1, 2) = "18. Ku"
    iChing(2, 2, 2, 2, 1, 1) = "19. Lin"
    iChing(1, 1, 2, 2, 2, 2) = "10. Kuan"
    iChing(1, 2, 1, 2, 2, 1) = "21. Shih Ho"
    iChing(1, 2, 2, 1, 2, 1) = "22. Pi"
    iChing(1, 2, 2, 2, 2, 2) = "23. Po"
    iChing(2, 2, 2, 2, 2, 1) = "24. Fu"
    iChing(1, 1, 1, 2, 2, 1) = "25. Wu Wang"
    iChing(1, 2, 2, 1, 1, 1) = "26. Ta Ch'u"
    iChing(1, 2, 2, 2, 2, 1) = "27. I"
    iChing(2, 1, 1, 1, 1, 2) = "28. Ta Kuo"
    iChing(2, 1, 2, 2, 1, 2) = "29. K'an"
    iChing(1, 2, 1, 1, 2, 1) = "20. Li"
    iChing(2, 1, 1, 1, 2, 2) = "31. Hsien"
    iChing(2, 2, 1, 1, 1, 2) = "32. Hng"
    iChing(1, 1, 1, 1, 2, 2) = "33. Tun"
    iChing(2, 2, 1, 1, 1, 1) = "34. Ta Chuang"
    iChing(1, 2, 1, 2, 2, 2) = "35. Chin"
    iChing(2, 2, 2, 1, 2, 1) = "36. Ming I"
    iChing(1, 1, 2, 1, 2, 1) = "37. Chia Jn"
    iChing(1, 2, 1, 2, 1, 1) = "38. K'uei"
    iChing(2, 1, 2, 1, 2, 2) = "39. Chien"
    iChing(2, 2, 1, 2, 1, 2) = "30. Hsieh"
    iChing(1, 2, 2, 2, 1, 1) = "41. Sun"
    iChing(1, 1, 2, 2, 2, 1) = "42. I"
    iChing(2, 1, 1, 1, 1, 1) = "43. Kuai"
    iChing(1, 1, 1, 1, 1, 2) = "44. Kou"
    iChing(2, 1, 1, 2, 2, 2) = "45. Ts'ui"
    iChing(2, 2, 2, 1, 1, 2) = "46. Shng"
    iChing(2, 1, 1, 2, 1, 2) = "47. K'un"
    iChing(2, 1, 2, 1, 1, 2) = "48. Ching"
    iChing(2, 1, 1, 1, 2, 1) = "49. Ko"
    iChing(1, 2, 1, 1, 1, 2) = "40. Ting"
    iChing(2, 2, 1, 2, 2, 1) = "51. Chn"
    iChing(1, 2, 2, 1, 2, 2) = "52. Kn"
    iChing(1, 1, 2, 1, 2, 2) = "53. Chien"
    iChing(2, 2, 1, 2, 1, 1) = "54. Kuei Mei"
    iChing(2, 2, 1, 1, 2, 1) = "55. Fng"
    iChing(1, 2, 1, 1, 2, 2) = "56. L"
    iChing(1, 1, 2, 1, 1, 2) = "57. Sun"
    iChing(2, 1, 1, 2, 1, 1) = "58. Tui"
    iChing(1, 1, 2, 2, 1, 2) = "59. Huan"
    iChing(2, 1, 2, 2, 1, 1) = "50. Chieh"
    iChing(1, 1, 2, 2, 1, 1) = "61. Chung Fu"
    iChing(2, 2, 1, 1, 2, 2) = "62. Hsiao Kuo"
    iChing(2, 1, 2, 1, 2, 1) = "63. Chi Chi"
    iChing(1, 2, 1, 2, 1, 2) = "64. Wei Chi"

1 iChingDescription(1) = "The Creative" & " - " & "HEAVEN,  HEAVEN "
2 iChingDescription(2) = "The Receptive" & " - " & "EARTH,  EARTH "
3 iChingDescription(3) = "Difficulty at the Beginning" & " - " & "WATER,  THUNDER "
4 iChingDescription(4) = "Immaturity (Youthful Folly)" & " - " & "MOUNTAIN,  WATER "
5 iChingDescription(5) = "Waiting" & " - " & "WATER,  HEAVEN "
6 iChingDescription(6) = "Conflict" & " - " & "HEAVEN,  WATER "
7 iChingDescription(7) = "The Army" & " - " & "EARTH,  WATER "
8 iChingDescription(8) = "Holding Together (Union)" & " - " & "WATER,  EARTH "
9 iChingDescription(9) = "The Taming Power of the Small" & " - " & "WIND,  HEAVEN "
10 iChingDescription(10) = "Treading (Conduct)" & " - " & "HEAVEN,  LAKE "
11 iChingDescription(11) = "Peace (Contentment)" & " - " & "EARTH,  HEAVEN "
12 iChingDescription(12) = "Standstill (Stagnation)" & " - " & "HEAVEN,  EARTH "
13 iChingDescription(13) = "Fellowship with People" & " - " & "HEAVEN,  FLAME "
14 iChingDescription(14) = "Possession in Great Measure" & " - " & "FLAME,  HEAVEN "
15 iChingDescription(15) = "Modesty" & " - " & "EARTH,  MOUNTAIN "
16 iChingDescription(16) = "Enthusiasm" & " - " & "THUNDER,  EARTH "
17 iChingDescription(17) = "Following" & " - " & "LAKE,  THUNDER "
18 iChingDescription(18) = "Removing Corruption (Decay)" & " - " & "MOUNTAIN,  WIND "
19 iChingDescription(19) = "Approach (Becoming Great)" & " - " & "EARTH,  LAKE "
20 iChingDescription(20) = "Contemplation (View)" & " - " & "WIND,  EARTH "
21 iChingDescription(21) = "Biting Through (Judging)" & " - " & "FLAME,  THUNDER "
22 iChingDescription(22) = "Grace (Adornment)" & " - " & "MOUNTAIN,  FLAME "
23 iChingDescription(23) = "Splitting Apart (Disintegration)" & " - " & "MOUNTAIN,  EARTH "
24 iChingDescription(24) = "Return (The Turning Point)" & " - " & "EARTH, THUNDER "
25 iChingDescription(25) = "Innocence (The Unexpected)" & " - " & "HEAVEN THUNDER "
26 iChingDescription(26) = "The Taming Power of the Great" & " - " & "MOUNTAIN, HEAVEN "
27 iChingDescription(27) = "Providing Nourishment (The Corners of the Mouth)" & " - " & "MOUNTAIN, THUNDER "
28 iChingDescription(28) = "Great Heaviness" & " - " & "LAKE,  WIND/WOOD "
29 iChingDescription(29) = "The Abysmal (Pitfalls)" & " - " & "WATER, WATER "
30 iChingDescription(30) = "The Clinging" & " - " & "FLAME, FLAME "
31 iChingDescription(31) = "Influence (Wooing)" & " - " & "LAKE, MOUNTAIN "
32 iChingDescription(32) = "Duration (Marriage)" & " - " & "THUNDER WIND "
33 iChingDescription(33) = "Retreat (Withdrawal)" & " - " & "HEAVEN, MOUNTAIN "
34 iChingDescription(34) = "The Power of the Great" & " - " & "THUNDER, HEAVEN "
35 iChingDescription(35) = "Progress" & " - " & "FLAME, EARTH "
36 iChingDescription(36) = "Darkening of the Light" & " - " & "EARTH  FLAME "
37 iChingDescription(37) = "The Family (The Clan)" & " - " & "WIND, FLAME "
38 iChingDescription(38) = "Opposition" & " - " & "FLAME, LAKE "
39 iChingDescription(39) = "Obstruction" & " - " & "WATER, MOUNTAIN "
40 iChingDescription(40) = "Deliverance" & " - " & "THUNDER, WATER "
41 iChingDescription(41) = "Decrease" & " - " & "MOUNTAIN, LAKE "
42 iChingDescription(42) = "Increase" & " - " & "WIND, THUNDER "
43 iChingDescription(43) = "Break-through (Resoluteness)" & " - " & "LAKE, HEAVEN "
44 iChingDescription(44) = "Coming to Meet  (Encountering)" & " - " & "HEAVEN, WIND "
45 iChingDescription(45) = "Gathering Together (Massing)" & " - " & "LAKE, EARTH "
46 iChingDescription(46) = "Pushing UpwardsEARTH" & " - " & "WIND, WOOD "
47 iChingDescription(47) = "Oppression (Exhaustion)" & " - " & "LAKE, WATER "
48 iChingDescription(48) = "The Well" & " - " & "WATER, WIND, WOOD "
49 iChingDescription(49) = "Revolution (Fundamental Change)" & " - " & "LAKE, FLAME "
50 iChingDescription(50) = "The Great Bowl (Sacred Vessel)" & " - " & "FLAME, WIND, WOOD "
51 iChingDescription(51) = "Thunder (Shock)" & " - " & "THUNDER, THUNDER "
52 iChingDescription(52) = "Keeping Still" & " - " & "MOUNTAIN, MOUNTAIN "
53 iChingDescription(53) = "Development (Gradual Progress)" & " - " & "WIND, WOOD, MOUNTAIN "
54 iChingDescription(54) = "The MarrYangg Maiden (Love)" & " - " & "THUNDER, LAKE "
55 iChingDescription(55) = "Abundance (Fullness)" & " - " & "THUNDER, FLAME "
56 iChingDescription(56) = "Travel (The Seeker)" & " - " & "FLAME, MOUNTAIN "
57 iChingDescription(57) = "The Gentle (The Penetrating)" & " - " & "WIND, WOOD, WIND, WOOD "
58 iChingDescription(58) = "The Joyous" & " - " & "LAKE, LAKE "
59 iChingDescription(59) = "Dispersion (The Dissolving)" & " - " & "WIND, WATER "
60 iChingDescription(50) = "Limitation (Due Measure)" & " - " & "WATER, LAKE "
61 iChingDescription(61) = "Inner Truth" & " - " & "WIND, LAKE "
62 iChingDescription(62) = "Preponderance of the Small" & " - " & "THUNDER, MOUNTAIN "
63 iChingDescription(63) = "Order (After Completion)" & " - " & "WATER, FLAME "
64 iChingDescription(64) = "Transition (Before Completion)" & " - " & "FLAME, WATER "

End Function



Function SaveAlphaMatrix(iLattices As Integer)

    Dim iX As Integer
    Dim iY As Integer
        
    For iY = 0 To 7
        For iX = 0 To 7
            SaveSetting "Alpha2Hex", "AlphaMatrix", "ENTRY(" & iY & "," & iX & ")-T" & iLattices, AlphaMatrix(iY, iX, iLattices)
        Next iX
    Next iY
End Function

Function LoadAlphaMatrix(iLattices As Integer)
    Dim iX As Integer
    Dim iY As Integer
        
    For iY = 0 To 7
        For iX = 0 To 7
            AlphaMatrix(iY, iX, iLattices) = GetSetting("Alpha2Hex", "AlphaMatrix", "ENTRY(" & iY & "," & iX & ")-t" & iLattices, AlphaMatrix(iY, iX, iLattices))
        Next iX
    Next iY
    
End Function
Function SaveHexMatrix(iLattices As Integer)

    Dim iX As Integer
    Dim iY As Integer
        
    For iY = 0 To 7
        For iX = 0 To 7
            SaveSetting "Alpha2Hex", "HexMatrix", "ENTRY(" & iY & "," & iX & ")-T" & iLattices, HexagramMatrix(iY, iX, iLattices)
        Next iX
    Next iY
End Function

Function LoadHexMatrix(iLattices As Integer)
    Dim iX As Integer
    Dim iY As Integer
        
    For iY = 0 To 7
        For iX = 0 To 7
            HexagramMatrix(iY, iX, iLattices) = GetSetting("Alpha2Hex", "HexMatrix", "ENTRY(" & iY & "," & iX & ")-T" & iLattices, HexagramMatrix(iY, iX, iLattices))
        Next iX
    Next iY
    
End Function
Sub Main()
    
    LoadSettings
    Dim i As Integer
    
    
    i = SetHexMatrix(iLattices)
    i = SetAlphaMatrix(iLattices)
    
    i = LoadAlphaMatrix(iLattices)
    i = LoadHexMatrix(iLattices)
    
    frmMain.Show
    
End Sub
Function LoadSettings()
    
    MatrixDESCCaption(0) = "Traditional"
    MatrixDESCCaption(1) = "User 1"
    MatrixDESCCaption(2) = "User 2"
    MatrixDESCCaption(3) = "User 3"
    MatrixDESCCaption(4) = "User 4"
    MatrixDESCCaption(5) = "User 5"
    MatrixDESCCaption(6) = "User 6"
    MatrixDESCCaption(7) = "User 7"
    MatrixDESCCaption(8) = "User 8"
    MatrixDESCCaption(9) = "User 9"
    
    iFontName = GetSetting("Alpha2Hex", "Settings", "Fontname", iFontName)
    iLattices = GetSetting("Alpha2Hex", "Settings", "Template", iLattices)
    iFontSize = GetSetting("Alpha2Hex", "Settings", "FontSize", 8)
    iFontBold = GetSetting("Alpha2Hex", "Settings", "FontBold", False)
    
    iFirstTime = True
    iFirstTime = GetSetting("Alpha2Hex", "Settings", "FirstTimeLoad", iFirstTime)
    
    Dim i As Integer
    For i = 0 To 9: MatrixDESCCaption(i) = GetSetting("Alpha2Hex", "Settings", "Menu Captions" & i, MatrixDESCCaption(i)): Next
    
    Setting.NewLineOnvbCR = GetSetting("Alpha2Hex", "Settings", "NewLineCR", True)
    Setting.SpaceOnSpace = GetSetting("Alpha2Hex", "Settings", "SpaceOnSpace", True)
    Setting.SpaceUnsupported = GetSetting("Alpha2Hex", "Settings", "SpaceUnsupported", False)
    Setting.PrintChar = GetSetting("Alpha2Hex", "Settings", "PrintChar", False)
    Setting.MultiplexDisplay = GetSetting("Alpha2Hex", "Settings", "MulitpleLevel", False)
    
    Setting.Randomix = GetSetting("Alpha2Hex", "Settings", "Randomix", False)
    Setting.RandomixState = GetSetting("Alpha2Hex", "Settings", "RandomixState", 0)
    Setting.DateTimeSeed = GetSetting("Alpha2Hex", "Settings", "DateTimeSeed", True)
    Setting.UserSeed = GetSetting("Alpha2Hex", "Settings", "UserSeed", 1110.0101)
    Setting.ResetStats = GetSetting("Alpha2Hex", "Settings", "ResetStats", True)
    
    Setting.BestElemental = GetSetting("Alpha2Hex", "Settings", "BestElemental", False)
    Setting.ElementalYangorYin = GetSetting("Alpha2Hex", "Settings", "ElementalYangorYin", 0)
    
    Setting.Mayhem = GetSetting("Alpha2Hex", "Settings", "Mayhem", False)
    Setting.MayhemSeed = GetSetting("Alpha2Hex", "Settings", "MayhemSeed", 986.2412)
    Setting.MayhemDateTime = GetSetting("Alpha2Hex", "Settings", "MayhemDateTime", True)
    
    SetiChing
    
End Function

Function SaveSettings()

    SaveSetting "Alpha2Hex", "Settings", "Fontname", iFontName
    SaveSetting "Alpha2Hex", "Settings", "Template", iLattices
    SaveSetting "Alpha2Hex", "Settings", "FontSize", iFontSize
    SaveSetting "Alpha2Hex", "Settings", "FontBold", iFontBold

    Dim i As Integer
    For i = 0 To 9: SaveSetting "Alpha2Hex", "Settings", "Menu Captions" & i, MatrixDESCCaption(i): Next
    
    SaveSetting "Alpha2Hex", "Settings", "FirstTimeLoad", False

    SaveSetting "Alpha2Hex", "Settings", "NewLineCR", Setting.NewLineOnvbCR
    SaveSetting "Alpha2Hex", "Settings", "SpaceOnSpace", Setting.SpaceOnSpace
    SaveSetting "Alpha2Hex", "Settings", "SpaceUnsupported", Setting.SpaceUnsupported
    SaveSetting "Alpha2Hex", "Settings", "PrintChar", Setting.PrintChar
    SaveSetting "Alpha2Hex", "Settings", "MulitpleLevel", Setting.MultiplexDisplay
    SaveSetting "Alpha2Hex", "Settings", "Randomix", Setting.Randomix
    SaveSetting "Alpha2Hex", "Settings", "RandomixState", Setting.RandomixState
    SaveSetting "Alpha2Hex", "Settings", "DateTimeSeed", Setting.DateTimeSeed
    SaveSetting "Alpha2Hex", "Settings", "UserSeed", Setting.UserSeed
    SaveSetting "Alpha2Hex", "Settings", "ResetStats", Setting.ResetStats
    
    SaveSetting "Alpha2Hex", "Settings", "BestElemental", Setting.BestElemental
    SaveSetting "Alpha2Hex", "Settings", "ElementalYangorYin", Setting.ElementalYangorYin
    
    SaveSetting "Alpha2Hex", "Settings", "Mayhem", Setting.Mayhem
    SaveSetting "Alpha2Hex", "Settings", "MayhemSeed", Setting.MayhemSeed
    SaveSetting "Alpha2Hex", "Settings", "MayhemDateTime", Setting.MayhemDateTime
End Function
Function SetHexMatrix(ByRef iLattices As Integer)

    HexagramMatrix(0, 0, iLattices) = 1
    HexagramMatrix(0, 1, iLattices) = 34
    HexagramMatrix(0, 2, iLattices) = 5
    HexagramMatrix(0, 3, iLattices) = 26
    HexagramMatrix(0, 4, iLattices) = 11
    HexagramMatrix(0, 5, iLattices) = 9
    HexagramMatrix(0, 6, iLattices) = 14
    HexagramMatrix(0, 7, iLattices) = 43
    
    HexagramMatrix(1, 0, iLattices) = 25
    HexagramMatrix(1, 1, iLattices) = 51
    HexagramMatrix(1, 2, iLattices) = 3
    HexagramMatrix(1, 3, iLattices) = 27
    HexagramMatrix(1, 4, iLattices) = 24
    HexagramMatrix(1, 5, iLattices) = 42
    HexagramMatrix(1, 6, iLattices) = 21
    HexagramMatrix(1, 7, iLattices) = 17
    
    HexagramMatrix(2, 0, iLattices) = 6
    HexagramMatrix(2, 1, iLattices) = 40
    HexagramMatrix(2, 2, iLattices) = 29
    HexagramMatrix(2, 3, iLattices) = 4
    HexagramMatrix(2, 4, iLattices) = 7
    HexagramMatrix(2, 5, iLattices) = 59
    HexagramMatrix(2, 6, iLattices) = 64
    HexagramMatrix(2, 7, iLattices) = 47
    
    HexagramMatrix(3, 0, iLattices) = 33
    HexagramMatrix(3, 1, iLattices) = 62
    HexagramMatrix(3, 2, iLattices) = 39
    HexagramMatrix(3, 3, iLattices) = 52
    HexagramMatrix(3, 4, iLattices) = 15
    HexagramMatrix(3, 5, iLattices) = 53
    HexagramMatrix(3, 6, iLattices) = 56
    HexagramMatrix(3, 7, iLattices) = 31
    
    HexagramMatrix(4, 0, iLattices) = 12
    HexagramMatrix(4, 1, iLattices) = 16
    HexagramMatrix(4, 2, iLattices) = 8
    HexagramMatrix(4, 3, iLattices) = 23
    HexagramMatrix(4, 4, iLattices) = 2
    HexagramMatrix(4, 5, iLattices) = 20
    HexagramMatrix(4, 6, iLattices) = 35
    HexagramMatrix(4, 7, iLattices) = 45
    
    HexagramMatrix(5, 0, iLattices) = 44
    HexagramMatrix(5, 1, iLattices) = 32
    HexagramMatrix(5, 2, iLattices) = 48
    HexagramMatrix(5, 3, iLattices) = 18
    HexagramMatrix(5, 4, iLattices) = 46
    HexagramMatrix(5, 5, iLattices) = 57
    HexagramMatrix(5, 6, iLattices) = 50
    HexagramMatrix(5, 7, iLattices) = 28
    
    HexagramMatrix(6, 0, iLattices) = 13
    HexagramMatrix(6, 1, iLattices) = 55
    HexagramMatrix(6, 2, iLattices) = 63
    HexagramMatrix(6, 3, iLattices) = 22
    HexagramMatrix(6, 4, iLattices) = 36
    HexagramMatrix(6, 5, iLattices) = 37
    HexagramMatrix(6, 6, iLattices) = 30
    HexagramMatrix(6, 7, iLattices) = 49
    
    HexagramMatrix(7, 0, iLattices) = 10
    HexagramMatrix(7, 1, iLattices) = 54
    HexagramMatrix(7, 2, iLattices) = 60
    HexagramMatrix(7, 3, iLattices) = 41
    HexagramMatrix(7, 4, iLattices) = 19
    HexagramMatrix(7, 5, iLattices) = 61
    HexagramMatrix(7, 6, iLattices) = 38
    HexagramMatrix(7, 7, iLattices) = 58
    
End Function

Function SetAlphaMatrix(ByRef iLattices As Integer)

    Dim X As Integer, Y As Integer
    Dim iStar As String
    
    For Y = 0 To 7
        For X = 0 To 7
            Select Case HexagramMatrix(Y, X, iLattices)
            Case 1: AlphaMatrix(Y, X, iLattices) = ","
            Case 2: AlphaMatrix(Y, X, iLattices) = "-"
            Case 3: AlphaMatrix(Y, X, iLattices) = "0"
            Case 4: AlphaMatrix(Y, X, iLattices) = "1"
            Case 5: AlphaMatrix(Y, X, iLattices) = "2"
            Case 6: AlphaMatrix(Y, X, iLattices) = "3"
            Case 7: AlphaMatrix(Y, X, iLattices) = "4"
            Case 8: AlphaMatrix(Y, X, iLattices) = "5"
            Case 9: AlphaMatrix(Y, X, iLattices) = "6"
            Case 10: AlphaMatrix(Y, X, iLattices) = "7"
            Case 11: AlphaMatrix(Y, X, iLattices) = "8"
            Case 12: AlphaMatrix(Y, X, iLattices) = "9"
            Case 13: AlphaMatrix(Y, X, iLattices) = "A"
            Case 14: AlphaMatrix(Y, X, iLattices) = "B"
            Case 15: AlphaMatrix(Y, X, iLattices) = "C"
            Case 16: AlphaMatrix(Y, X, iLattices) = "D"
            Case 17: AlphaMatrix(Y, X, iLattices) = "E"
            Case 18: AlphaMatrix(Y, X, iLattices) = "F"
            Case 19: AlphaMatrix(Y, X, iLattices) = "G"
            Case 20: AlphaMatrix(Y, X, iLattices) = "H"
            Case 21: AlphaMatrix(Y, X, iLattices) = "I"
            Case 22: AlphaMatrix(Y, X, iLattices) = "J"
            Case 23: AlphaMatrix(Y, X, iLattices) = "K"
            Case 24: AlphaMatrix(Y, X, iLattices) = "L"
            Case 25: AlphaMatrix(Y, X, iLattices) = "M"
            Case 26: AlphaMatrix(Y, X, iLattices) = "N"
            Case 27: AlphaMatrix(Y, X, iLattices) = "O"
            Case 28: AlphaMatrix(Y, X, iLattices) = "P"
            Case 29: AlphaMatrix(Y, X, iLattices) = "Q"
            Case 30: AlphaMatrix(Y, X, iLattices) = "R"
            Case 31: AlphaMatrix(Y, X, iLattices) = "S"
            Case 32: AlphaMatrix(Y, X, iLattices) = "T"
            Case 33: AlphaMatrix(Y, X, iLattices) = "U"
            Case 34: AlphaMatrix(Y, X, iLattices) = "V"
            Case 35: AlphaMatrix(Y, X, iLattices) = "W"
            Case 36: AlphaMatrix(Y, X, iLattices) = "X"
            Case 37: AlphaMatrix(Y, X, iLattices) = "Y"
            Case 38: AlphaMatrix(Y, X, iLattices) = "Z"
            Case 39: AlphaMatrix(Y, X, iLattices) = "a"
            Case 40: AlphaMatrix(Y, X, iLattices) = "b"
            Case 41: AlphaMatrix(Y, X, iLattices) = "c"
            Case 42: AlphaMatrix(Y, X, iLattices) = "d"
            Case 43: AlphaMatrix(Y, X, iLattices) = "e"
            Case 44: AlphaMatrix(Y, X, iLattices) = "f"
            Case 45: AlphaMatrix(Y, X, iLattices) = "g"
            Case 46: AlphaMatrix(Y, X, iLattices) = "h"
            Case 47: AlphaMatrix(Y, X, iLattices) = "i"
            Case 48: AlphaMatrix(Y, X, iLattices) = "j"
            Case 49: AlphaMatrix(Y, X, iLattices) = "k"
            Case 50: AlphaMatrix(Y, X, iLattices) = "l"
            Case 51: AlphaMatrix(Y, X, iLattices) = "m"
            Case 52: AlphaMatrix(Y, X, iLattices) = "n"
            Case 53: AlphaMatrix(Y, X, iLattices) = "o"
            Case 54: AlphaMatrix(Y, X, iLattices) = "p"
            Case 55: AlphaMatrix(Y, X, iLattices) = "q"
            Case 56: AlphaMatrix(Y, X, iLattices) = "r"
            Case 57: AlphaMatrix(Y, X, iLattices) = "s"
            Case 58: AlphaMatrix(Y, X, iLattices) = "t"
            Case 59: AlphaMatrix(Y, X, iLattices) = "u"
            Case 60: AlphaMatrix(Y, X, iLattices) = "v"
            Case 61: AlphaMatrix(Y, X, iLattices) = "w"
            Case 62: AlphaMatrix(Y, X, iLattices) = "x"
            Case 63: AlphaMatrix(Y, X, iLattices) = "y"
            Case 64: AlphaMatrix(Y, X, iLattices) = "z"
            End Select
        Next
    Next

End Function
